<?xml version="1.0"?>

<!--
  Copyright (c) 1997-2012
  Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
  http://www.polymake.org

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version: http://www.gnu.org/licenses/gpl.txt.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
===============================================================================
  $Project: polymake $$Id: upgrade-2.12.1.xslt 11231 2013-04-19 21:52:38Z gawrilow $

  Make any SimplicialComplex containing one of GEOMETRIC_REALIZATION, G_DIM, VOLUME, SIGNATURE into a GeometricSimplicialComplex
  Change the property GEOMETRIC_REALIZATION to COORDINATES
-->

<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
			     xmlns:p="http://www.math.tu-berlin.de/polymake/#3">

<xsl:output method="xml" encoding="utf-8" cdata-section-elements="p:description" indent="yes" />


<!-- 1 -->

<!-- We search for objects with properties of a GeometricSimplicialComplex -->

<xsl:template match="p:object">
  <xsl:variable name="attr_type" select="@type" />
  <xsl:element name="object" namespace="{namespace-uri()}">
    <xsl:copy-of select="@*[name()!='tm' and name()!='version']" />
    <xsl:choose>
      <xsl:when test="$attr_type='topaz::SimplicialComplex'">
	<!-- we have a SimplicialComplex -->
	<xsl:variable name="has_GEOMETRIC_REALIZATION" select="./p:property[@name='GEOMETRIC_REALIZATION']" />
	<xsl:variable name="has_G_DIM" select="./p:property[@name='G_DIM']" />
	<xsl:variable name="has_VOLUME" select="./p:property[@name='VOLUME']" />
	<xsl:variable name="has_SIGNATURE" select="./p:property[@name='SIGNATURE']" />
	
	<xsl:if test="(count($has_GEOMETRIC_REALIZATION)>=1) or (count($has_G_DIM)>=1) or (count($has_VOLUME)>=1) or (count($has_SIGNATURE)>=1)">
	  <!-- we need to change the type to GeometricSimplicialComplex -->
	  <xsl:attribute name="type">topaz::GeometricSimplicialComplex&lt;Rational&gt;</xsl:attribute>
	</xsl:if>
	<xsl:for-each select="*">
	  <xsl:apply-templates select="." />
	</xsl:for-each>
      </xsl:when>
      
      <xsl:otherwise>
	<xsl:apply-templates  />
      </xsl:otherwise>

    </xsl:choose>
  </xsl:element>

</xsl:template>


<!-- the name GEOMETRIC_REALIZATION gets changed to COORDINATES -->

<xsl:template match="p:property[@name='GEOMETRIC_REALIZATION']">
  <xsl:element name="property" namespace="{namespace-uri()}">
    <xsl:attribute name="name">COORDINATES</xsl:attribute>
    <xsl:copy-of select="*" />
  </xsl:element>
</xsl:template>

<xsl:include href="trivial-copy.xslt" />


</xsl:transform>
