<?xml version="1.0"?>

<!--
  Copyright (c) 1997-2012
  Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
  http://www.polymake.org

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version: http://www.gnu.org/licenses/gpl.txt.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
===============================================================================
  $Project: polymake $$Id: upgrade-2.12.2.xslt 10156 2011-04-14 09:15:38Z sherrmann $

  In all objects of type Polytope:
    Replace MINKOWSKI_SUMMAND_CONE with MINKOWSKI_CONE.
-->

<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
			     xmlns:p="http://www.math.tu-berlin.de/polymake/#3">

<xsl:output method="xml" encoding="utf-8" cdata-section-elements="description" indent="yes" />

<!-- detect the LatticePolytope objects -->
<xsl:template match="/p:object[@type[contains(string(),'Polytope')]]">
  <xsl:element name="{name()}" namespace="{namespace-uri()}">
    <xsl:copy-of select="@*[name()!='tm' and name()!='version']" />
    <xsl:apply-templates select="./node()" mode="polytope" />
  </xsl:element>
</xsl:template>

<xsl:template match="p:property[@name='MINKOWSKI_SUMMAND_CONE']" mode="polytope">
  <xsl:element name="property" namespace="{namespace-uri()}">
    <xsl:attribute name="name">MINKOWSKI_CONE</xsl:attribute>
    <xsl:apply-templates select="./node()" mode="polytope" />
  </xsl:element>
</xsl:template>


<!-- everything else is copied verbatim by switching back to the default mode -->
<xsl:template match="*" mode="polytope">
  <xsl:apply-templates select="." />
</xsl:template>


<xsl:include href="trivial-copy.xslt" />

</xsl:transform>
