<?xml version="1.0"?>

<!--
  Copyright (c) 1997-2011
  Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
  http://www.polymake.de

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version: http://www.gnu.org/licenses/gpl.txt.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
===============================================================================
  $Project: polymake $$Id: upgrade-2.9.11.xslt 11296 2013-07-29 23:51:25Z gawrilow $

Property POLYTOPE_AMBIENT_DIM is changed to AMBIENT_DIM and property 
POLYTOPE_DIM is changed to DIM (only in PointConfigurations) 
-->


<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
			     xmlns:p="http://www.math.tu-berlin.de/polymake/#3">

<xsl:output method="xml" encoding="utf-8" cdata-section-elements="p:description" indent="yes" />


<!-- detect PointConfiguration objects -->
<xsl:template match="/p:object[@type[contains(string(),'PointConfiguration')]]">
  <xsl:element name="{name()}" namespace="{namespace-uri()}">
    <xsl:copy-of select="@*[name()!='tm' and name()!='version']" />
    <xsl:apply-templates select="./node()" mode="pointconfig"/>
  </xsl:element>
</xsl:template>

<xsl:template match="p:property[@name='POLYTOPE_DIM']" mode="pointconfig">
  <xsl:element name="property" namespace="{namespace-uri()}">
    <xsl:attribute name="name">DIM</xsl:attribute>
    <xsl:attribute name="value">
      <xsl:value-of select="@value" />
    </xsl:attribute>
  </xsl:element>
</xsl:template>

<xsl:template match="p:property[@name='POLYTOPE_AMBIENT_DIM']" mode="pointconfig">
  <xsl:element name="property" namespace="{namespace-uri()}">
    <xsl:attribute name="name">AMBIENT_DIM</xsl:attribute>
    <xsl:attribute name="value">
	<xsl:value-of select="@value" />
    </xsl:attribute>
  </xsl:element>
</xsl:template>

<!-- everything else is copied verbatim by switching back to the default mode -->
<xsl:template match="*" mode="pointconfig">
  <xsl:apply-templates select="." />
</xsl:template>

<xsl:include href="trivial-copy.xslt" />

</xsl:transform>
