<?xml version="1.0"?>

<!--
  Copyright (c) 1997-2009
  Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
  http://www.polymake.de

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version: http://www.gnu.org/licenses/gpl.txt.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
===============================================================================
  $Project: polymake $$Id: upgrade-2.9.3.xslt 11296 2013-07-29 23:51:25Z gawrilow $

  Enclose subobjects in property tags.
  Multiple subobjects become children of the same property node.
-->

<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
			     xmlns:p="http://www.math.tu-berlin.de/polymake/#3">

<xsl:output method="xml" encoding="utf-8" cdata-section-elements="description" indent="yes" />

<xsl:template match="p:object/p:object">
   <xsl:variable name="prop_name" select="@name" />
   <xsl:if test="count(preceding-sibling::p:object[@name=$prop_name])=0">
      <xsl:element name="property" namespace="{namespace-uri()}">
         <xsl:attribute name="name"><xsl:value-of select="$prop_name" /></xsl:attribute>
         <xsl:for-each select=".|following-sibling::p:object[@name=$prop_name]">
            <xsl:element name="object" namespace="{namespace-uri()}">
	       <xsl:if test="last()>1">
                  <xsl:attribute name="name"><xsl:value-of select="position()-1" /></xsl:attribute>
               </xsl:if>
               <xsl:copy-of select="@type" />
  	       <xsl:apply-templates select="./node()" />
            </xsl:element>
	 </xsl:for-each>
      </xsl:element>
   </xsl:if>
</xsl:template>

<xsl:include href="trivial-copy.xslt" />

</xsl:transform>
